    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ------------------------------
    028     * MultiValueCategoryDataset.java
    029     * ------------------------------
    030     * (C) Copyright 2007, by David Forslund and Contributors.
    031     *
    032     * Original Author:  David Forslund;
    033     * Contributor(s):   David Gilbert (for Object Refinery Limited);;
    034     *
    035     * Changes
    036     * -------
    037     * 08-Oct-2007 : Version 1, see patch 1780779 (DG);
    038     *
    039     */
    040
    041    package org.jfree.data.statistics;
    042
    043    import org.jfree.data.category.CategoryDataset;
    044
    045    import java.util.List;
    046
    047    /**
    048     * A category dataset that defines multiple values for each item.
    049     *
    050     * @since 1.0.7
    051     */
    052    public interface MultiValueCategoryDataset extends CategoryDataset {
    053
    054        /**
    055         * Returns a list (possibly empty) of the values for the specified item.
    056         * The returned list should be unmodifiable.
    057         *
    058         * @param row  the row index (zero-based).
    059         * @param column   the column index (zero-based).
    060         *
    061         * @return The list of values.
    062         */
    063        public List getValues(int row, int column);
    064
    065        /**
    066         * Returns a list (possibly empty) of the values for the specified item.
    067         * The returned list should be unmodifiable.
    068         *
    069         * @param rowKey  the row key (<code>null</code> not permitted).
    070         * @param columnKey  the column key (<code>null</code> not permitted).
    071         *
    072         * @return The list of values.
    073         */
    074        public List getValues(Comparable rowKey, Comparable columnKey);
    075
    076    }